unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, Menus, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Edit1: TEdit;
    Button1: TButton;
    StringGrid1: TStringGrid;
    Button2: TButton;
    Memo1: TMemo;
    Button3: TButton;
    procedure Button1Click(Sender: TObject);
    procedure StringGrid1DrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}
function fak(n: integer):integer;
begin
  if n = 0 then result := 1 else result := n*fak(n-1);
end;


procedure stringgridFuerVerknuepfungstafel(sg: TStringgrid; n:integer);
  var k:integer;
begin
  sg.ColCount := n+1;
  sg.RowCount := n+1;
  sg.FixedRows := 1;
  sg.FixedCols := 1;
  sg.cells[0,0] := '*'; //Verknpfungstabelle fr '*'
  for k := 0 to n do Begin
    sg.ColWidths[k] := 30;
    sg.RowHeights[k] := 30;
  End;
  sg.Align := alclient;
end;

procedure instringrid(sg: Tstringgrid; i,j:integer; inhalt:string);
begin
 sg.Cells[j,i] := inhalt;
end;

procedure ordnechar(var s:string; k,n:integer); //bubblesort
  var i,j:integer;
      x:char;
begin
  for i := k to n do for j := i+1 to n do
    if s[i] > s[j] then Begin
      x := s[i];
      s[i] := s[j];
      s[j] := x
    End;
end;

procedure tausche(var s:string; const k:integer);
  var  i: integer;
       c: char;
begin
    ordnechar(s,k,length(s));
    //Tausche mit dem kleinsten aus s[k] s[k+1] ... s[n] das grer als s[k-1] ist
    c := s[k-1];
    for i := k to length(s) do
      if c < s[i] then Begin
        s[k-1] := s[i];
        s[i] := c; //getauscht!
        break;
      End;
    ordnechar(s,k,length(s));
end;

procedure naechstePermutation(var s: string);
  var k:integer; //z.B. s='12543' k=3
begin
  k:= length(s);
  while (s[k] < s[k-1]) and (k > 0) do dec(k);
  if k =1 then s := '' else
  //Tausch s[k-1] mit dem kleinste Element aus s[k], s[k+1] ...
  //Rest alphabetisch sortieren
  Tausche(s,k);
end;

function mal(a,b:string):string;
  const s='abcdefg'; //maximal 7
      //z.B. a='bca' d.h. a->b b->c c->a
      //     b='cba' d.h. a->c b->b c->a
      //a*b (b nach a) a->c->a b->b->c c->a->b, also a*b='acb'
  var k,j,n:integer;
begin
  n := length(b);
  result := '';
  for k := 1 to n do
    for j := 1 to n do
      if b[k] = s[j] then Begin
        result := result + a[j];
        break;
      End;
end;

procedure TForm1.Button1Click(Sender: TObject);
  var n,i,j,f:integer;
      s: string;
begin
  memo1.Hide;
  stringgrid1.Show;
  n := strToInt(edit1.text);
  if n > 7 then n := 7; //schon das drfte zuviel werden
  f := fak(n);
  s := copy('abcdefg',1,n);
  stringgridFuerVerknuepfungstafel(stringgrid1,f - 1);
  //1. Spalte
  for i := 1 to f - 1 do Begin
    instringrid(stringgrid1,i,0,s);
    naechstePermutation(s);
  End;
 //1. Reihe
  s := copy('abcdefg',1,n);
  for j := 1 to f - 1 do Begin
    instringrid(stringgrid1,0,j,s);
    naechstePermutation(s);
  End;
  //Verknpfungstafel
  for i := 1 to f - 1 do for j := 1 to f - 1 do
     instringrid(stringgrid1,i,j,mal(stringgrid1.cells[i,0],stringgrid1.cells[0,j]));
end;

procedure TForm1.StringGrid1DrawCell(Sender: TObject; ACol, ARow: Integer;
                                     Rect: TRect; State: TGridDrawState);
begin
 with sender as Tstringgrid do
   if cells[ACol,ARow]='0' then Begin
     StringGrid1.Canvas.Font.Color := clred;
     //StringGrid1.Canvas.Brush.Color := clblue;
     StringGrid1.canvas.fillRect(Rect);
    StringGrid1.canvas.TextOut(Rect.Left,Rect.Top,StringGrid1.Cells[ACol,ARow]);
 End;
end;

{function invers(s:string):string;
  var j: integer;
begin
   with form1.StringGrid1 do
   for j := 1 to Rowcount - 1 do
   if mal(s, Cells[0,j]) = Cells[0,1]
     then result := Cells[0,j];
end;}

function invers(s:string):string;
  var i,j: integer;
begin
   with form1.StringGrid1 do
   for i := 1 to Rowcount - 1 do
     if cells[0,i] = s then
       for j := 1 to Colcount - 1 do
        if cells[j,i] = cells[0,1] then Begin
          result := cells[0,j];
          exit;
        End;
   result := '-';
end;

procedure TForm1.Button2Click(Sender: TObject);
  var i,j: integer;
      s:string;
begin
  stringgrid1.Hide;
  with memo1 do Begin
    show;
    Align := alClient;
    Text := '<table border="1">';
    lines.add('Verknpfungstabelle a*b=a&nbsp;nach&nbsp;b');
    for i := 0 to stringgrid1.Rowcount - 1 do Begin
      s:='  <tr>';
      for j := 0 to stringgrid1.Colcount - 1  do Begin
        if (i=0) or (j=0) then
          s := s + '<td bgcolor="silver">'+ stringgrid1.cells[j,i] + '</td>'
           else if stringgrid1.cells[j,i] = '0' then
             s := s + '<td><font color="red">'+ stringgrid1.cells[j,i] + '</font></td>' else
               s := s + '<td>'+ stringgrid1.cells[j,i] + '</td>';
      End;
      s := s + '</tr>';
      lines.Add(s);
    End;
    lines.add('</table>');
    //Noch die Inversen
    lines.add(#13#10'<br> <br>'#13#10);
    lines.add('<table border="1">');
    s := '  <tr> <td bgcolor="silver">x</td>';
    for j := 1 to stringgrid1.Rowcount - 1 do s := s + '<td>' + stringgrid1.cells[0,j] + '</td>';
    lines.Add(s+'</tr>');
    s := '  <tr> <td bgcolor="silver">Inverses</td>';
    for j := 1 to stringgrid1.Rowcount - 1 do
      s := s + '<td>' + invers(stringgrid1.cells[0,j]) + '</td>';
    lines.Add(s+'</tr>');
    lines.add('</table>');
  End;
end;

procedure TForm1.Button3Click(Sender: TObject);
  var i,j,k,n,f: integer;
      s: string;
begin
  n := strToInt(edit1.text);
  f := fak(n);
  s := copy('abcdefg',1,n);
  with form1.StringGrid1 do
  for k := 1 to f do Begin
    for i := 0 to f - 1 do
      for j := 0 to f - 1 do
        if cells[j,i] = s then cells[j,i] := IntToStr(k);
    naechstePermutation(s);
  End;
end;

end.
